#include <RadioLib.h>

SX1262 radio = new Module(8, 14, 12, 13);

int counter = 0;

void setup() {
  Serial.begin(115200);

  Serial.print(F("[SX1262] Initializing ... "));
  int state = radio.beginFSK(868.3, 8.21, 57.136417, 234.3, 10, 32);

  if (state == RADIOLIB_ERR_NONE) {
    Serial.println(F("success!"));
  } else {
    Serial.print(F("failed, code "));
    Serial.println(state);
    while (true);
  }

  uint8_t syncWord[] = {0x01, 0x23, 0x45, 0x67, 0x89, 0xAB, 0xCD, 0xEF};
  state = radio.setSyncBits(syncWord, 12);

  state = radio.setCRC(0);
}

void loop() {
  // receive FSK packet
  String str;
  int state = radio.receive(str);
  int rssi = radio.getRSSI();
  int snr = radio.getSNR();
  int ferr = radio.getFrequencyError();

  counter = counter + 1;

  if (state == RADIOLIB_ERR_NONE) {
    Serial.printf("[SX1262] - counter [%5d] - state [%5d] - rssi [%3d] snr [%3d] ferr [%3d] - Received packet! - data: %x \n\n", counter, state, rssi, snr, ferr, str);
    counter = 0;
  } else if (state == RADIOLIB_ERR_RX_TIMEOUT) {
    Serial.printf("[SX1262] - counter [%5d] - state [%5d] - rssi [%3d] snr [%3d] ferr [%3d] - Timed out while waiting for packet! \n", counter, state, rssi, snr, ferr) ;
  } else {
    Serial.printf("[SX1262] - counter [%5d] - state [%5d] - rssi [%3d] snr [%3d] ferr [%3d] - Failed to receive packet \n", counter, state, rssi, snr, ferr);
  }
}
